/* ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : PTC.h
**     Project     : ProcessorExpert
**     Processor   : MKL16Z128VFT4
**     Component   : Init_GPIO
**     Version     : Component 01.006, Driver 01.06, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2015-02-26, 19:47, # CodeGen: 0
**     Abstract    :
**          This file implements the GPIO (PTC) module initialization
**          according to the Peripheral Initialization settings, and
**          defines interrupt service routines prototypes.
**     Settings    :
**          Component name                                 : PTC
**          Device                                         : PTC
**          Settings                                       : 
**            Pin 0                                        : Initialize
**              Pin direction                              : Output
**              Output value                               : 0
**              Pull resistor                              : Disabled
**              Pull selection                             : Pull Down
**              Slew rate                                  : Slow
**              Interrupt/DMA request                      : No initialization
**            Pin 1                                        : Do not initialize
**            Pin 2                                        : Initialize
**              Pin direction                              : Output
**              Output value                               : 0
**              Pull resistor                              : Disabled
**              Pull selection                             : Pull Down
**              Slew rate                                  : Slow
**              Interrupt/DMA request                      : No initialization
**            Pin 3                                        : Initialize
**              Pin direction                              : Input
**              Output value                               : 1
**              Pull resistor                              : Enabled
**              Pull selection                             : Pull Up
**              Slew rate                                  : Slow
**              Interrupt/DMA request                      : Interrupt on either edge
**            Pin 4                                        : Initialize
**              Pin direction                              : Input
**              Output value                               : 1
**              Pull resistor                              : Enabled
**              Pull selection                             : Pull Up
**              Slew rate                                  : Slow
**              Interrupt/DMA request                      : Interrupt on either edge
**            Pin 5                                        : Initialize
**              Pin direction                              : Input
**              Output value                               : No initialization
**              Pull resistor                              : No initialization
**              Pull selection                             : No initialization
**              Slew rate                                  : No initialization
**              Interrupt/DMA request                      : No initialization
**            Pin 6                                        : Do not initialize
**            Pin 7                                        : Initialize
**              Pin direction                              : Output
**              Output value                               : 0
**              Pull resistor                              : Disabled
**              Pull selection                             : Pull Up
**              Slew rate                                  : Slow
**              Interrupt/DMA request                      : No initialization
**          Pin selection/routing                          : 
**            Pin 0                                        : Enabled
**              Pin                                        : ADC0_SE14/TSI0_CH13/PTC0/EXTRG_IN/CMP0_OUT/I2S0_TXD0
**              Pin signal                                 : 
**            Pin 1                                        : Disabled
**            Pin 2                                        : Enabled
**              Pin                                        : ADC0_SE11/TSI0_CH15/PTC2/I2C1_SDA/TPM0_CH1/I2S0_TX_FS
**              Pin signal                                 : 
**            Pin 3                                        : Enabled
**              Pin                                        : PTC3/LLWU_P7/UART1_RX/TPM0_CH2/CLKOUT/I2S0_TX_BCLK
**              Pin signal                                 : 
**            Pin 4                                        : Enabled
**              Pin                                        : PTC4/LLWU_P8/SPI0_PCS0/UART1_TX/TPM0_CH3/I2S0_MCLK
**              Pin signal                                 : 
**            Pin 5                                        : Enabled
**              Pin                                        : PTC5/LLWU_P9/SPI0_SCK/LPTMR0_ALT2/I2S0_RXD0/CMP0_OUT
**              Pin signal                                 : 
**            Pin 6                                        : Disabled
**            Pin 7                                        : Enabled
**              Pin                                        : CMP0_IN1/PTC7/SPI0_MISO/I2S0_RX_FS/SPI0_MOSI
**              Pin signal                                 : 
**          Interrupts                                     : 
**            Port interrupt                               : Enabled
**              Interrupt                                  : INT_PORTC_PORTD
**              Interrupt request                          : Enabled
**              Interrupt priority                         : 0 (Highest)
**              ISR Name                                   : PORTC_PORTD_ISR
**          Initialization                                 : 
**            Call Init method                             : yes
**     Contents    :
**         Init - void PTC_Init(void);
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file PTC.h
** @version 01.06
** @brief
**          This file implements the GPIO (PTC) module initialization
**          according to the Peripheral Initialization settings, and
**          defines interrupt service routines prototypes.
*/         
/*!
**  @addtogroup PTC_module PTC module documentation
**  @{
*/         

#ifndef PTC_H_
#define PTC_H_

/* MODULE PTC. */

/* Including shared modules, which are used in the whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "Cpu.h"

/* Peripheral base address parameter */
#define PTC_DEVICE PTC_BASE_PTR

/* Peripheral port base address parameter */
#define PTC_PORT_DEVICE PORTC_BASE_PTR



/*
** ===================================================================
**     Method      :  PTC_Init (component Init_GPIO)
**     Description :
**         This method initializes registers of the GPIO module
**         according to the Peripheral Initialization settings.
**         Call this method in user code to initialize the module. By
**         default, the method is called by PE automatically; see "Call
**         Init method" property of the component for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void PTC_Init(void);
/*
** ===================================================================
** The interrupt service routine must be implemented by user in one
** of the user modules (see PTC.c file for more information).
** ===================================================================
*/
PE_ISR(PORTC_PORTD_ISR);


/* END PTC. */
#endif /* #ifndef __PTC_H_ */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
