/*
 * File:		io.c
 * Purpose:		Serial Input/Output routines
 *
 * Notes:       TERMINAL_PORT defined in <board>.h
 */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "UART0.h"
/* Including shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

#include "uart.h"
#include "common.h"

/********************************************************************/
char
in_char (void)
{
	return uart_getchar( (UART_MemMapPtr)TERM_PORT);
}
/********************************************************************/
void
out_char (char ch)
{
	//uart_putchar(TERM_PORT, ch);
	uart_irq_putchar( (UART_MemMapPtr)TERM_PORT, ch);
}
/********************************************************************/
int
char_present (void)
{
	return uart_getchar_present( (UART_MemMapPtr) TERM_PORT);
}
/********************************************************************/
