/*
 * device_MMA9553L.h
 *
 *  Created on: Oct 1, 2014
 *      Author: Jacob Postman
 *		Copyright: Revolution Robotics, Inc. 
 *		License: Createive Commons Attribution-ShareAlike 4.0 International (CC BY-SA 4.0)
 */

#ifndef DEVICE_MMA9553L_H_
#define DEVICE_MMA9553L_H_

#include "../WaRP_DB.h"

extern struct device_t MMA9553L_dev;
void mmaHandler(char* jsonStr, jsmntok_t *jsmnTkns);

int initMMA9553L(void);
int getPedometerData(void);


// MMA Application ID
#define MMA955X_APP_VER				0x00
#define MMA955X_APP_SCH				0x01
#define MMA955X_APP_GPIO			0x03
#define MMA955X_APP_MBX				0x04
#define MMA955X_APP_AFE				0x06
#define MMA955X_APP_ORIENT			0x07
#define MMA955X_APP_HIGHG			0x08
#define MMA955X_APP_LOWG			0x09
#define MMA955X_APP_TAPDET			0x0A
#define MMA955X_APP_TILT			0x0B
#define MMA955X_APP_FRMCNT			0x0E
#define MMA955X_APP_DATAFIFO		0x0F
#define MMA955X_APP_EVNTQ			0x10
#define MMA955X_APP_STATUS			0x11
#define MMA955X_APP_SLPWAKE			0x12
#define MMA955X_APP_PED				0x15
#define MMA955X_APP_RSTCTRL			0x17
#define MMA955X_APP_MBXCFG			0x18

// Registers
#define MAILBOX0 					0x00


#endif /* DEVICE_MMA9553L_H_ */
