/*
 * File:		uart.h
 * Purpose:     Provide common ColdFire UART routines for polled serial IO
 *
 * Notes:
 */

#ifndef __UART_H__
#define __UART_H__

/********************************************************************/

#define uartTxRegEmpty() (UART0_S1 & UART_S1_TDRE_MASK)
#define uartRxRegFull() (UART0_S1 & UART_S1_RDRF_MASK)


void uart_init (UART_MemMapPtr, int, int);
char uart_getchar (UART_MemMapPtr);
void uart_putchar (UART_MemMapPtr, char);
void uart_irq_putchar (UART_MemMapPtr channel, char ch);
int uart_getchar_present (UART_MemMapPtr);

/********************************************************************/

#endif /* __UART_H__ */
